################################################################
# Make CORBA demo for Orbacus
################################################################

.SUFFIXES:	.cpp .idl .obj

CC=cl.exe
LD=link.exe
CPP=$(CC)
IDL=idl
CFLAGS=/MD /O1 /W3 /GX /GR /Gy /DWIN32 /nologo -Ipl -I. -DORBACUS
LDFLAGS=/DLL /nologo
PLLDFLAGS=$(LDFLAGS) -goal true
LIBS=OB.lib jtc.lib libpl.lib user32.lib
STUBBER=pl/cwrapper.pl pl/cclient.pl pl/cutil.pl

MOD=test

SERVEROBJ=	$(MOD).obj $(MOD)_skel.obj $(MOD)-impl.obj $(MOD)-server.obj \
		pl2omni.obj
CLIENTOBJ=	$(MOD)-clientstub.obj $(MOD).obj pl2omni.obj

SERVERPL=	server.pl
DEPPL=		$(MOD)-impl.pl
TARGET=		server.dll client.dll

all:		$(TARGET)

server.dll:	$(SERVEROBJ)
		$(LD) /out:$@ /DLL $(SERVEROBJ) $(LDFLAGS) $(LIBS)
client.dll:	$(CLIENTOBJ)
		$(LD) /out:$@ /DLL $(CLIENTOBJ) $(LDFLAGS) $(LIBS)

server:		$(SERVEROBJ) $(SERVERPL) $(DEPPL)
		plld $(PLLDFLAGS) -o $@ $(SERVEROBJ) $(LIBS) $(SERVERPL)

$(SERVEROBJ):	$(MOD).h
$(CLIENTOBJ):	$(MOD).h

$(MOD)-impl.cpp: $(MOD).idl $(STUBBER)
		pl\pl-stubber.bat --orb=orbacus $(MOD).idl

$(MOD)-clientstub.cpp:	$(MOD).idl  $(STUBBER)
		pl\pl-stubber.bat --orb=orbacus --client $(MOD).idl

test.idl:	tests.pl
		pl -f mkidl.pl -g mkidl,halt

test.h:		test.idl
		$(IDL) test.idl

pl2omni.cpp:	pl/pl2ilu.c
		copy /b pl\pl2ilu.c $@

cosnaming.dll:	cosnaming.o
		$(LD) /out:$@ $< $(LDFLAGS) CosNaming.lib $(LIBS)

cosnaming.cpp:	pl/cosnaming.cpp
		copy /b $< $@

.cpp.obj:
		$(CXX) /c $(CFLAGS) $<

clean:		
		del *.obj *.dll a.out *~ core IOR server.pid tmp.cpp tmp.i
		del $(MOD).cpp $(MOD)_skel.cpp $(MOD)-impl.cpp $(MOD).h
		del $(MOD)-clientstub.cpp $(MOD)-skel.pl $(MOD)_skel.h
		del pl2omni.cpp

distclean:	clean
		rm -f $(TARGET)
