/*  $Id: corba.pl,v 1.1.1.1 2001/01/24 15:20:59 jan Exp $

    Part of SWI-Prolog CORBA interface
    Designed and implemented by Jan Wielemaker
    E-mail: jan@swi.psy.uva.nl

    Copyright (C) 1998 University of Amsterdam. All rights reserved.
*/

:- module(corba,
	  [ corba_send/2,
	    corba_get/3,
	    corba_narrow/3,
	    corba_widen/3
	  ]).

:- initialization op(999, yfx, ?).

Return := Self?Term :- !,
	corba_get(Self, Term).
Self?Term :-
	corba_send(Self, Term).

corba_send(Self, Term) :-
	Self = 'CORBA_object'(Module, Interface, _Reference),
	Term =.. [Method|Args],
	concat_atom([Interface, Method], '_', Predicate),
	Goal =.. [Predicate, Self|Args],
	Module:Goal.

corba_get(Self, Term, Return) :-
	Self = 'CORBA_object'(Module, Interface, _Reference),
	Term =.. [Method|Args],
	concat_atom([Interface, Method], '_', Predicate),
	Goal =.. [Predicate, Self|Args],
	call(Module:Goal, Return).

corba_narrow('CORBA_object'(Module, _Interface, Reference),
	     Interface,
	     'CORBA_object'(Module, Interface, Reference)).

corba_widen('CORBA_object'(Module, _Interface, Reference),
	     Interface,
	     'CORBA_object'(Module, Interface, Reference)).
