#include <OB/CORBA.h>

#include <stdlib.h>
#include <test.h>
#include <SWI-Prolog.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include <malloc.h>

namespace test
{
  extern void PL_test__InitializeServer(void);
}

static void
interrupt(int sig)
{ PL_action(PL_ACTION_HALT, 0);
}

int
main(int argc, char **argv)
{ predicate_t mainpred;
  char **av = (char **)alloca(sizeof(char **) * (argc+4));
  int an, ac=0;

  av[ac++] = argv[0];
  av[ac++] = "-F";
  av[ac++] = "xpce";
  av[ac++] = "--";
  for(an=1; an<argc; an++)
    av[ac++] = argv[an];
  av[ac] = NULL;

#ifdef ILU_X
  XtToolkitInitialize();
  ilu_Xt_Initialize(NULL, NULL);
#endif

  putenv("SWI_HOME_DIR=/staff/jan/lib/pl-3.4.4");
  if ( !PL_initialise(ac, av) )
    PL_halt(1);

  signal(SIGINT, interrupt);

  test::PL_test__InitializeServer();

  mainpred = PL_predicate("main", 0, "user");

  return PL_call_predicate(NULL, TRUE, mainpred, 0) ? 0 : 1;
}
