/*  $Id: tests.pl,v 1.1.1.1 2001/01/24 15:20:58 jan Exp $

    Part of SWI-Prolog CORBA interface
    Designed and implemented by Anjo Anjewierden and Jan Wielemaker
    E-mail: jan@swi.psy.uva.nl

    Copyright (C) 1998 University of Amsterdam. All rights reserved.
*/

:- module(corba_test_data,
	  [ test_data/2,		% ?Type, ?Data
	    test_interface/1		% ?Interface
	  ]).

%	test_data(?TypeId, ?Example)
%
%	Data to use in the test.  Currently, only one example value is
%	allowed for a type.  It is not trivial how this should be improved,
%	as there is no backtracking over the CORBA connection.  Should be
%	fixed somehow (for example by enumerating the test cases and
%	maintaining a counter at both sides.

test_data(scalar, 		42).
test_data(boolean, 		true).
test_data(day, 			monday).
test_data(string, 		'Hello World').
test_data(scalar_list,		[ -42, -1, 0, 1, 42
				]).
test_data(var_record_list,	[ var_record(aap, "aap"),
				  var_record(noot, "noot")
				]).
test_data(fixed_record_list,	[ fixed_record(aap, 1),
				  fixed_record(noot, 1)
				]).
test_data(fixed_union,		fixed_union(vf_name, hello)).
test_data(var_union,		var_union(vv_list, [1,2,3])).

%	test_interface(?Interface)
%
%	Type of argument passing to test (in, return, out, exception context)

test_interface(input).
test_interface(answer).
test_interface(output).
test_interface(except).
       
